var p $p$, mu $\mu$, lambda $\lambda$, x $x$, c $c$, chat $\hat{c}$ ;
var a $a$, b $b$, w $w$, n $n$, y $y$, mt $mt$, etaht $\eta^{ht}$ ;
var yT $yT$, yN $yN$, pT $pT$, pN $pN$, pY $pY$ ;
var what $\hat{w}$, wshat $\hat{w}^s$, pNhat $\hat{p}^N$ ;
var pNshat $\hat{p}^{N,s}$, pThat $\hat{p}^T$, pTshat $\hat{p}^{T,s}$ ;
var muhat $\hat{\mu}$, nhat $\hat{n}$, Tr $T^r$, etant $\eta^{n,t}$ ;
var z $z$, bett $\beta^t$, debt $\text{debt}$ spend $\text{spend}$ ;

varexo em $\varepsilon^m$, eh $\varepsilon^h$ ;
varexo ez $\varepsilon^z$, en $\varepsilon^n$, eb $\varepsilon^b$ ;

parameters bet $\beta$, gamm $\gamma$, nu $\nu$ ;
parameters etah $\eta_h$, hbar $\bar{h}$, mbar $\bar{m}$ ;
parameters alph $\alpha$, etan $\eta_n$, sigmac $\sigma_c$ ;
parameters qss $q$, omega $\omega$, sigma $\sigma$, kappa $\kappa$ ;
parameters pTss $p_T$, pYss $p_Y$, Yss $Y$, rho $\rho$, rhow $\rho_w$ ;
parameters psi $\psi$, wss $w$, muss $\mu$, nss $n$, pNss $p_N$ ;
parameters pXss $p_X$ rhom $\rho_m$, sigmam $\sigma_m$, rhoh $\rho_h$ ;
parameters sigmah $\sigma_h$, rhoz $\rho_z$, sigmaz $\sigma_z$ ;
parameters rhon $\rho_n$, sigman $\sigma_n$, rhob $\rho_b$ ;
parameters sigmab $\sigma_b$, bss $b$, pss $p$ ;     
parameters rhomMA $\rho_n^{\text{MA}}$ ;
parameters rhohMA $\rho_z^{\text{MA}}$ ;

load input;             % load parameters and steady state

bet    = params(1) ; 
gamm   = params(2) ;
nu     = params(3) ; 
etah   = params(4) ; 
hbar   = params(5) ; 
mbar   = params(6) ; 
alph   = params(7) ; 
etan   = params(8) ; 
sigmac = params(9) ;
qss    = params(10) ; 
omega  = params(11) ; 
sigma  = params(12) ; 
kappa  = params(13) ; 
pTss   = params(14) ; 
pYss   = params(15) ; 
Yss    = params(16) ; 
rho    = params(17) ; 
rhow   = params(18) ; 
psi    = params(19) ; 
wss    = params(20) ; 
muss   = params(21) ; 
nss    = params(22) ; 
pNss   = params(23) ; 
pXss   = params(24) ; 
rhom   = params(25) ;
sigmam = params(26) ;
rhoh   = params(27) ;
sigmah = params(28) ;
rhoz   = params(29) ;
sigmaz = params(30) ;
rhon   = params(31) ;
sigman = params(32) ; 
rhob   = params(33) ;
sigmab = params(34) ; 
bss    = params(35) ;
pss    = params(36) ;
rhomMA = params(37) ;
rhohMA = params(38) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  MODEL  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

var spendobs_ $\text{spend}^\text{obs}$ ;
var nobs_ $\text{n}^\text{obs}$ ;
var wobs_ $\text{w}^\text{obs}$ ;
var debtobs_ $\text{debt}^\text{obs}$ ;
var pobs_ $\text{p}^\text{obs}$ ;

var etamtMA etahtMA ;

var asset debt2;

var nNobs_ nTobs_ ;

model ;

exp(p)*exp(mu) = exp(bett)*exp(etaht)/hbar + exp(bett)*exp(p(+1))*exp(mu(+1)) + exp(lambda)*exp(mt)*exp(p);  
exp(mu)/(exp(bett)*(1+gamm*qss)/qss*exp(mu(+1))) = 1 + (qss*exp(lambda) - exp(bett)*gamm*exp(lambda(+1))*qss)/(exp(bett)*(1 + gamm*qss)*exp(mu(+1)));
exp(mu)/(exp(bett)*(1+gamm*qss)/qss*exp(mu(+1))) = 1 + sigmac/(alph - sigmac)*(exp(x)/exp(chat))^(-alph); 
exp(chat)^(-sigmac)  = exp(bett)*(1+gamm*qss)/qss*exp(mu(+1))*exp(pY); 
exp(c)         = (alph/(alph - 1) - 1/(alph - 1)*(exp(x)/exp(chat))^(1-alph))*exp(chat); 
exp(a)         = exp(pY)/qss*(exp(x) - exp(c)); 
exp(c)         = exp(y); 
qss*exp(b)     = gamm*qss*exp(b(-1)) + exp(mt)*exp(p)*hbar; 
exp(n)         = (exp(yT) + exp(yN))/exp(z); 
exp(yT)        = (1-omega)*(exp(pT)/pTss)^(-kappa)*(pTss/pYss)^(-sigma)*Yss;
exp(yN)        = omega*(exp(pN)/exp(pY))^(-sigma)*exp(y); 
exp(pY)        = (omega*exp(pN)^(1-sigma) + (1-omega)*pTss^(1-sigma))^(1/(1-sigma)); 
exp(pY)*exp(y) + qss*(exp(a) - exp(b)) = exp(w)*exp(n) + (1 + gamm*qss)*(exp(a(-1)) - exp(b(-1))) + Tr;
Tr             = (exp(pT) - exp(w - z))*exp(yT) + (exp(pN) - exp(w - z))*exp(yN);
wshat          = bet*rhow*wshat(+1) + (1 - rhow*bet)/(1 + psi*nu)*(-muhat + psi*nu*what + etant - log(etan) + nu*nhat); 
what           = rhow*(what(-1)) + (1 - rhow)*wshat; 
pNshat         = bet*rho*pNshat(+1) + (1-bet*rho)*(what - z); 
pNhat          = rho*pNhat(-1) + (1-rho)*pNshat;
pTshat         = bet*rho*pTshat(+1) + (1-bet*rho)*(what - z); 
pThat          = rho*pThat(-1) + (1-rho)*pTshat;

pNhat          = pN - pNss;
pThat          = pT - pXss; 
what           = w - wss; 
muhat          = mu - muss; 
nhat           = n - nss; 

mt             = (1-rhom)*log(mbar) + rhom*mt(-1)    + etamtMA ; 
etaht          = (1-rhoh)*log(etah) + rhoh*etaht(-1) + etahtMA ;
etahtMA        = rhohMA * etahtMA(-1) + (1/1)*sigmah*eh; 
etant          = (1-rhon)*log(etan) + rhon*etant(-1) + 1*(1/1)*sigman*en; 
etamtMA        = rhomMA * etamtMA(-1) + (1/1)*sigmam*em;
bett           = (1-rhob)*log(bet)  + rhob*bett(-1)  + (1/1000)*sigmab*eb;
z              =                      rhoz*z(-1) + (1/100)*sigmaz*ez   ; 

debt           =  gamm*debt(-1) + exp(mt)*exp(p)*hbar; 
asset          = qss*exp(a)/Yss;
spend          = pY + y;

spendobs_ = 100*(spend - log(pYss*Yss)) ;
nobs_     = 100*(n - nss) ;
wobs_     = 100*(w - wss) ;
debtobs_  = 1*((debt/(Yss)) - (bss*qss/Yss)) ;
pobs_     = 10*(p-log(pss)) ;

debt2=qss*exp(b)/Yss;

nNobs_     = 100*(yN-z - Yss) ;
nTobs_     = 100*(yT-z - Yss) ;

end;

shocks; 

var em = 1;
var eh = 1;
var ez = 1;
var en = 1; 
var eb = 1;

end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  END MODEL   %%%%%%%%%%%%%%%%%%%%%%%%%%%%

initval;

p       = xsteady(1); 
mu      = xsteady(3);
lambda  = xsteady(5);
x       = xsteady(6);
c       = xsteady(7);
chat    = xsteady(8);
a       = xsteady(9);
b       = xsteady(10);
w       = xsteady(11);
n       = xsteady(12);
y       = xsteady(13);
mt      = log(mbar); 
etaht   = log(etah); 
yT      = xsteady(14); 
yN      = xsteady(15);
pT      = xsteady(16); 
pN      = xsteady(17);
pY      = xsteady(18); 
what    = 0;  
wshat   = 0;
pNhat   = 0;
pNshat  = 0;
pThat   = 0;
pTshat  = 0;
Tr      = 0; 
etant   = log(etan);
z       = 0; 
bett    = log(bet);
debt    = qss*exp(b)/Yss;
spend   = pY + y;

end;

steady;
stoch_simul(order = 1, irf = 29, nograph, periods = 0, conditional_variance_decomposition=[2 4 12]);

