stnames={'AK'
'AL'
'AR' 
'AZ' %4
'CA' %5
'CO'
'CT'
'DC'
'DE'
'FL' %10
'GA'
'HI'
'IA'
'ID'
'IL'
'IN'
'KS'
'KY'
'LA'
'MA'
'MD'
'ME'
'MI'
'MN'
'MO'
'MS'
'MT'
'NC'
'ND'
'NE'
'NH'
'NJ'
'NM'
'NV' %34
'NY'
'OH'
'OK'
'OR'
'PA'
'RI'
'SC'
'SD'
'TN'
'TX'
'UT'
'VA'
'VT'
'WA'
'WI'
'WV'
'WY'};

data_in=csvread('data_for_matlab.csv') ;

setweights = 0 ;
plotfig    = 0 ;

%%

Nyears  = 17 ;
Nstates = 51 ;

pop         = data_in(1:Nstates*Nyears, 2); % state population
pop         = reshape(pop, Nyears, Nstates); 

weights     = pop(1,:) ;
weights     = weights' / sum(weights) ;

SET.weights = weights ;

weightsnorm = weights./max(weights) ; % Compute relative size of states

tmp = weightsnorm>0.0 ; % If wanting to delete small states

idx = repmat(tmp',[Nyears,1]) ;
idx = reshape(idx,[Nyears*Nstates 1]) ;

Cdata = log(data_in(idx>0,4).^(1/1)) ;
Ndata = log(data_in(idx>0,5).^(1/1)) ;
Wdata = log(data_in(idx>0,6).^(1/1)) ;
Ddata = data_in(idx>0,7)*4 ;
Qdata = log(data_in(idx>0,8).^(1/1)) ;

Nstates = sum(tmp) ;

pop         = data_in(idx>0, 2); % state population
pop         = reshape(pop, Nyears, Nstates); 

year       = repmat((1:1:Nyears)', Nstates, 1); 
iyear      = dummyvar(year);
iyear(:,1) = []; 
 
T = Nyears ; 
N = T*Nstates; 
n = N/T;

% Matrices for Fixed Effects Regressions

Jbar  = ones(T)./T;
E     = eye(T) - Jbar;           % Matrix that compute differences from group mean
P     = kron(eye(n), Jbar);      % Compute group means and replicate for all observations in the group
Qm     = eye(N) - P;             % Compute differences from group means
     
x     = [iyear];
 
Xfe   = [x ones(N,1)];

DdataL = reshape(Ddata,[Nyears,Nstates]) ;
DdataL = [DdataL(1,:) ; DdataL(1:end-1,:)] ;

k     = size(Xfe,2);               % number of variables

pop         = pop(1:end,:); 
pop         = pop(:); 
 
Omega       = diag(pop); 

% Employment, data
 
y           = reshape(Ndata, Nyears, Nstates); 
y           = reshape(y(1:end, :), (Nyears)*Nstates, 1); 
yfe         = Qm*y; yfe_n = yfe ;
coefnd      = (Xfe'*Omega*Xfe)\Xfe'*Omega*yfe;   % weighted
ypredn      = Xfe*coefnd ;
n_res       = yfe - ypredn ;

if SET.statetrend==1

X2 = [ones(17,1) (1:17)'];
X2 = kron(eye(n),X2) ;

coeftr = (X2'*X2)\X2'*n_res ;
n_res_tr      = X2*coeftr ;

n_res = n_res - n_res_tr ;

end
 
% Wages, data
 
y           = reshape(Wdata, Nyears, Nstates); 
y           = reshape(y(1:end, :), (Nyears)*Nstates, 1); 
yfe         = Qm*y; yfe_w = yfe ;
coefwd      = (Xfe'*Omega*Xfe)\Xfe'*Omega*yfe;   % weighted
ypredw      = Xfe*coefwd ;
w_res       = yfe - ypredw ;

if SET.statetrend==1

X2 = [ones(17,1) (1:17)'];
X2 = kron(eye(n),X2) ;

coeftr = (X2'*X2)\X2'*w_res ;
w_res_tr      = X2*coeftr ;

w_res = w_res - w_res_tr ;

end
 
% Consumption, data
 
y           = reshape(Cdata, Nyears, Nstates); 
y           = reshape(y(1:end, :), (Nyears)*Nstates, 1); 
yfe         = Qm*y; yfe_c = yfe ;
coefcd      = (Xfe'*Omega*Xfe)\Xfe'*Omega*yfe;   % weighted
ypredc      = Xfe*coefcd ;
c_res       = yfe - ypredc ;

if SET.statetrend==1

X2 = [ones(17,1) (1:17)'];
X2 = kron(eye(n),X2) ;

coeftr = (X2'*X2)\X2'*c_res ;
c_res_tr      = X2*coeftr ;

c_res = c_res - c_res_tr ;

end
 
% House prices, data
 
y           = reshape(Qdata, Nyears, Nstates); 
y           = reshape(y(1:end, :), (Nyears)*Nstates, 1); 
yfe         = Qm*y; yfe_q = yfe ;
coefqd      = (Xfe'*Omega*Xfe)\Xfe'*Omega*yfe;   % weighted
ypredq      = Xfe*coefqd ;
q_res       = yfe - ypredq ;

if SET.statetrend==1

X2 = [ones(17,1) (1:17)'];
X2 = kron(eye(n),X2) ;

coeftr = (X2'*X2)\X2'*q_res ;
q_res_tr      = X2*coeftr ;

q_res = q_res - q_res_tr ;

end

% Debt, data
 
y           = reshape(Ddata, Nyears, Nstates); 
y           = reshape(y(1:end, :), (Nyears)*Nstates, 1); 
yfe         = Qm*y; yfe_d = yfe ;
coefdd      = (Xfe'*Omega*Xfe)\Xfe'*Omega*yfe;   % weighted
ypredd      = Xfe*coefdd ;
d_res       = yfe - ypredd ;

if SET.statetrend==1

X2 = [ones(17,1) (1:17)'];
X2 = kron(eye(n),X2) ;

coeftr = (X2'*X2)\X2'*d_res ;
d_res_tr      = X2*coeftr ;

d_res = d_res - d_res_tr ;

end

X2 = [ones(17,1)];
X2 = kron(eye(n),X2) ;
X3 = X2.*repmat(ypredd,[1, 51]);

coeff = ([d_res X3]'*[d_res X3])\[d_res X3]'*n_res;


if plotfig
figure;
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 5]) ;
subplot(2,3,1) ; tmp = reshape(y,Nyears,Nstates) ; 
    plot(1999:2015,tmp(:,5),'LineWidth',2,'Color',[0 127/256 190/256])
    box('off') ; grid ;
    xlim([2001 2012]) ;
    xlabel('Year') ;
    title('CA - Relative to 2001') ;
subplot(2,3,2) ; tmp = reshape(yfe,Nyears,Nstates) ; 
    plot(1999:2015,tmp(:,5),'LineWidth',2,'Color',[0 127/256 190/256])
    line([2001 2012],[0 0],'LineWidth',1,'Color','k')
    box('off') ; grid ;
    xlim([2001 2012]) ;
    %ylim([-0.6 0.6]) ;
    xlabel('Year') ;
    title('CA - Relative to state mean') ;
subplot(2,3,3) ; tmp = reshape(d_res,Nyears,Nstates) ; 
    plot(1999:2015,tmp(:,5),'LineWidth',2,'Color',[0 127/256 190/256])
    line([2001 2012],[0 0],'LineWidth',1,'Color','k')
    box('off') ; grid ;
    xlim([2001 2012]) ;
    %ylim([-2 2]) ;
    xlabel('Year') ;
    title('CA - Time effects removed') ;
subplot(2,3,4) ; tmp = reshape(y,Nyears,Nstates) ; 
    plot(1999:2015,tmp(:,44),'LineWidth',2,'Color',[0 127/256 190/256])
    box('off') ; grid ;
    xlim([2001 2012]) ;
    ylim([0 6]) ;
    xlabel('Year') ;
    title('TX - Relative to 2001') ;
subplot(2,3,5) ; tmp = reshape(yfe,Nyears,Nstates) ; 
    plot(1999:2015,tmp(:,44),'LineWidth',2,'Color',[0 127/256 190/256])
    line([2001 2012],[0 0],'LineWidth',1,'Color','k')
    box('off') ; grid ;
    ylim([-4 4]) ;
    xlim([2001 2012]) ;
    xlabel('Year') ;
    title('TX - Relative to state mean') ;
subplot(2,3,6) ; tmp = reshape(d_res,Nyears,Nstates) ; 
    plot(1999:2015,tmp(:,44),'LineWidth',2,'Color',[0 127/256 190/256])
    line([2001 2012],[0 0],'LineWidth',1,'Color','k')
    box('off') ; grid ;
    xlim([2001 2012]) ;
    ylim([-2 2]) ;
    xlabel('Year') ;
    title('TX - Time effects removed') ;
print -depsc ./debt.eps
close ;     


figure ;
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 9]) ;
tmp = reshape(d_res,Nyears,Nstates) ; 
for ii=1:51
subplot(8,7,ii); hold on ;
line([1999 2015],[0 0],'LineWidth',0.5,'Color','k')
plot(1999:2015,tmp(:,ii),'LineWidth',1)
grid ;
box('off') ;
xlim([1999 2015]) ;
title(stnames{ii}) ;
end
set(findall(gcf,'-property','FontSize'),'FontSize',6) ;
eval(['print -depsc ./debt_all_', int2str(SET.statetrend), '.eps']);
close ;   

figure ;
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 9]) ;
tmp = reshape(n_res,Nyears,Nstates) ; 
for ii=1:51
subplot(8,7,ii); hold on ;
line([1999 2015],[0 0],'LineWidth',0.5,'Color','k')
plot(1999:2015,tmp(:,ii),'LineWidth',1)
grid ;
box('off') ;
xlim([1999 2015]) ;
title(stnames{ii}) ;
end
set(findall(gcf,'-property','FontSize'),'FontSize',6) ;
eval(['print -depsc ./n_all_', int2str(SET.statetrend), '.eps']);
close ;   

figure ;
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 9]) ;
tmp = reshape(w_res,Nyears,Nstates) ; 
for ii=1:51
subplot(8,7,ii); hold on ;
line([1999 2015],[0 0],'LineWidth',0.5,'Color','k')
plot(1999:2015,tmp(:,ii),'LineWidth',1)
grid ;
box('off') ;
xlim([1999 2015]) ;
title(stnames{ii}) ;
end
set(findall(gcf,'-property','FontSize'),'FontSize',6) ;
eval(['print -depsc ./w_all_', int2str(SET.statetrend), '.eps']);
close ;   

figure ;
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 9]) ;
tmp = reshape(c_res,Nyears,Nstates) ; 
for ii=1:51
subplot(8,7,ii); hold on ;
line([1999 2015],[0 0],'LineWidth',0.5,'Color','k')
plot(1999:2015,tmp(:,ii),'LineWidth',1)
grid ;
box('off') ;
xlim([1999 2015]) ;
title(stnames{ii}) ;
end
set(findall(gcf,'-property','FontSize'),'FontSize',6) ;
eval(['print -depsc ./c_all_', int2str(SET.statetrend), '.eps']);
close ;   

figure ;
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 10 9]) ;
tmp = reshape(q_res,Nyears,Nstates) ; 
for ii=1:51
subplot(8,7,ii); hold on ;
line([1999 2015],[0 0],'LineWidth',0.5,'Color','k')
plot(1999:2015,tmp(:,ii),'LineWidth',1)
grid ;
box('off') ;
xlim([1999 2015]) ;
title(stnames{ii}) ;
end
set(findall(gcf,'-property','FontSize'),'FontSize',6) ;
eval(['print -depsc ./q_all_', int2str(SET.statetrend), '.eps']);
close ;   

end

NQuarters = Nyears*4 ;
Q_idx = 1:4:NQuarters ;

weights = weights./max(weights) ;

weights = 1*repmat(weights',[Nyears,1]) ;

tmp = weightsnorm>0.0 ;
tmp = repmat(tmp',[Nyears,1]);

tmp3 = weights(tmp>0);

weights = 0 + 1*reshape(tmp3,Nyears,Nstates) ;

if setweights==0
    weights = 1 + 0*weights ;
end

c_tmp = reshape(c_res,Nyears,Nstates).*weights ;
n_tmp = reshape(n_res,Nyears,Nstates).*weights ;
w_tmp = reshape(w_res,Nyears,Nstates).*weights ;
d_tmp = reshape(d_res,Nyears,Nstates).*weights ;
q_tmp = reshape(q_res,Nyears,Nstates).*weights ;

for tt=1:Nyears
    for jj=1:Nstates
        r_data{jj}(1,Q_idx(tt)) = 100*c_tmp(tt,jj) ;
        r_data{jj}(2,Q_idx(tt)) = 100*n_tmp(tt,jj) ;
        r_data{jj}(3,Q_idx(tt)) = 100*w_tmp(tt,jj) ;
        r_data{jj}(4,Q_idx(tt)) = 1*d_tmp(tt,jj) ;
        r_data{jj}(5,Q_idx(tt)) = 10*q_tmp(tt,jj) ;
        
    end
    
    SET.TT(Q_idx(tt)) = 1 ;
end
