function out = r_resolve_(SET,dyn_in)

%%

param_names = cellstr(dyn_in.M_.param_names) ;

for ii=1:dyn_in.M_.param_nbr
    eval(['',param_names{ii},'=dyn_in.M_.params(',int2str(ii),');']) ;
end

% recompute SS

r          = 0.02/4; 

hydata     = 2.52*4;                                  % U.S. stock of housing to income
dhdata     = 0.29; 
dydata     = dhdata*hydata;

mbar       = (1-gamm)*dhdata; 

% Compute Steady State

euler     = @(xchat, dydata, alph) 1 + dydata - xchat*(alph/(alph - 1) - 1/(alph - 1)*xchat^(1-alph))^(-1);

[xchatss,tmp,exitflag] = fzero(@(xchat) euler(xchat, dydata, alph), 10);

if exitflag<1 ; out = [] ; return ; end

Delta     = sigmac/(alph - sigmac)*xchatss^(-alph);
bet      = ((1 + r)*(1+Delta))^(-1);

% Given bet, all other stuff is trivial to compute

rss       = r; 
qss       = 1/(1 + r - gamm); 
Fss       = (alph/(alph-1) - 1/(alph-1)*xchatss.^(1-alph));

muss      = (etan)^(sigmac/(sigmac + nu)).*Fss.^(nu*sigmac/(sigmac + nu))./(bet.*(1 + r)).^(nu/(sigmac + nu)); 
lambdass  =  muss.*(1 - bet*(1 + r))./(1 - bet*gamm); 
chatss    = (bet.*(1 + r).*muss).^(-1/sigmac); 
css       = (muss./etan).^(1/nu);
xss       = chatss.*xchatss; 
Yss       = css;
nss       = Yss;
wss       = etan*nss^nu/muss;

phss      = hydata.*css; 
etah      = phss./bet.*muss.*(1 - bet - lambdass./muss.*mbar);

qbss      = mbar*phss./(1 - gamm); 
qass      = (xss - css); 

pss       = phss/hbar;
bss       = qbss./qss; 
ass       = qass./qss;
dyss      = qss*bss/css;

yTss      = (1 - omega)*Yss; 
yNss      = omega*Yss;

wss       = log(wss) ;
muss      = log(muss) ;
nss       = log(nss) ;

r_set_params

dyn_in.M_.params = out ;

out = [] ;

%%

mats_out = dyn_to_str(dyn_in) ;

if dyn_in.solve
    out.mats.Q = mats_out.mats.Q ;
    out.mats.G = mats_out.mats.G ; 
end

out.str_mats.A0 = mats_out.mats.A ;
out.str_mats.A1 = mats_out.mats.B ;
out.str_mats.B0 = mats_out.mats.D ;
out.str_mats.D0 = mats_out.mats.E ;
out.str_mats.D2 = mats_out.mats.D2 ;

out.mat_init    = out.str_mats ; 
out.mat_fin     = out.str_mats ; 

out.zlb.mat_init    = out.mat_init ; 