function [y_til, S, flag, Sigma] = kf_(SET, Ct, Pt, Dt, H, data, TT)
%
% 
%
%%

n_   = SET.variable.n_ ;
l_   = SET.variable.l_ ;
ss   = SET.ss ;
nobs = SET.nobs ;
flag = 0 ;

M_   = SET.M_ ;
oo_  = SET.oo_ ;

%% Initialize

Omega  = SET.Omega ;
Sigma = SET.Sigma ;

S     = zeros(nobs,nobs,ss) ;
y_til = zeros(nobs,ss) ; 
x     = zeros(n_-1,nobs) ;
P     = zeros(n_-1,n_-1,nobs) ;
K     = zeros(n_-1,nobs,ss) ;

Ph = Sigma ;
xh = ((eye(n_-1) - Pt(:,:,1))) \ Ct(:,:,1)  ;

%% Kalman filter

for t=1:ss
    hidx = SET.EST.hidx ;
    if TT(t)==0 ; hidx = SET.EST.hidx_no_obs ; end 
    
	% Predict
    x(:,t) = Ct(:,:,t)+Pt(:,:,t)*xh ;
    P(:,:,t) = Pt(:,:,t)*Ph*Pt(:,:,t)' + ...
        Dt(:,:,t)*Omega*Dt(:,:,t)' ;
    
    % Update
    y_til(hidx,t) = data(hidx,t) - H(hidx,:)*x(:,t) ;
    S(hidx,hidx,t) = H(hidx,:)*P(:,:,t)*H(hidx,:)' ;
    K(:,hidx,t) = P(:,:,t)*H(hidx,:)' / S(hidx,hidx,t) ;
    xh = x(:,t) + K(:,hidx,t)*y_til(hidx,t);
    Ph = (eye(n_-1) - K(:,hidx,t)*H(hidx,:))*P(:,:,t) ; 
end