%
%
%

clear all
clc

warning('Off','all') ;

path(pathdef)

addpath('./output') ;
addpath('./aggregate') ;
addpath('./regional') ;
addpath('./routines') ;
addpath('./routines/solmat') ;
addpath('./../data/aggregate') ;
addpath('./../data/state') ;

%%

% load data and simulations with credit shocks only
dat = csvread('results_matlab_baseline_em_eh.csv') ;

% State locations:
%  - Arizona is 4
%  - Nevada is 34

ln_data=dat(:,4);
debt_data=dat(:,6);
ln_model=dat(:,9);
debt_model=dat(:,11);

ln_data=reshape(ln_data,[17,51]);
ln_model=reshape(ln_model,[17,51]);

debt_data=reshape(debt_data,[17,51]);
debt_model=reshape(debt_model,[17,51]);

years=1999:2015;
ln_data_boom=ln_data(years==2007,:)-ln_data(years==2002,:);
ln_model_boom=ln_model(years==2007,:)-ln_model(years==2002,:);
ln_data_bust=ln_data(years==2010,[4 34])-ln_data(years==2007,[4 34]);
ln_model_bust=ln_model(years==2010,[4 34])-ln_model(years==2007,[4 34]);
debt_data_bust=debt_data(years==2010,[4 34])-debt_data(years==2007,[4 34]);
debt_model_bust=debt_model(years==2010,[4 34])-debt_model(years==2007,[4 34]);

tableout=[debt_data_bust debt_model_bust; 100*ln_data_bust 100*ln_model_bust];

ln_data_bust=ln_data(years==2013,[4 34])-ln_data(years==2007,[4 34]);
ln_model_bust=ln_model(years==2013,[4 34])-ln_model(years==2007,[4 34]);
debt_data_bust=debt_data(years==2013,[4 34])-debt_data(years==2007,[4 34]);
debt_model_bust=debt_model(years==2013,[4 34])-debt_model(years==2007,[4 34]);

tableout=[tableout;[debt_data_bust debt_model_bust; 100*ln_data_bust 100*ln_model_bust]];

latex(tableout,'%.2f','nomath')
