clc

state_table = [] ;

load ./output/posterior_save.mat

maxproc = SET.EST.chains ;

SET.EST.burn_in = 0.5 ;

params_x_   = [] ;

for runs=1:maxproc
    params_x_ = [params_x_ ; ...
        params_x(round(length(params_x)*SET.EST.burn_in):end,:,runs)] ; %#ok<AGROW>
end

for ii=1:length(params_x_(1,:))
    [x,y] = ksdensity(params_x_(:,ii),'NumPoints',200) ;
    params_out(ii) = y(x==max(x)) ;
end

state_table = [
state_table params_out' mean(params_x_(:,:))' prctile(params_x_(:,:),[10 90])' ] ;

fprintf(sprintf('\nHousehold Debt Baseline Parameter Estimates: alpha, theta_p, theta_w \n')) 
latex(state_table([2 3 1],[2 3 4]),'%.2f','nomath')

