
clear all
clc

warning('Off','all') ;

addpath('./output') ;
addpath('./aggregate') ;
addpath('./regional') ;
addpath('./routines') ;
addpath('./routines/solmat') ;
addpath('./../data/aggregate') ;
addpath('./../data/state') ;

SET.experiment = 'baseline' ;

SET.horizon = 1 ; 

%% Set up regional model

r_setup_model

table_unconditional=oo_.variance_decomposition([SET.variable.spendobs_ SET.variable.nobs_ ...
    SET.variable.wobs_ SET.variable.debtobs_ ...
    SET.variable.pobs_],:);

SET.table_unconditional=table_unconditional;

%% Set up aggregate model

a_setup_model

%% Table

table=[] ;

table_unconditional=oo_.variance_decomposition([SET.variable.c ...
    SET.variable.nhat ...
    SET.variable.w ...
    SET.variable.debtincome ...
    SET.variable.p ...
    SET.variable.iobs ...
    SET.variable.pai],:);

clc

disp('Unconditional Variance Decomposition, State-Level') ;
latex(SET.table_unconditional, '%.1f', 'nomath' ) ;
disp('')
disp('Unconditional Variance Decomposition, Aggregate-Level') ;
latex(table_unconditional, '%.1f', 'nomath' ) ;