
clear all 
set more off 

insheet statenum pop year c_data n_data w_data debt_data q_data using "../../data/state/data_for_matlab.csv", comma 

gen lc_data = ln(c_data)
gen ln_data = ln(n_data)
gen lw_data = ln(w_data)
gen lq_data = ln(q_data)

sort statenum year 
merge statenum using statename
drop _merge  

rename statename state
order state

xtset statenum year 
sort statenum year  

xtreg lc_data i.year [weight=pop], fe
predict lc_data_e, e

xtreg ln_data i.year [weight=pop], fe
predict ln_data_e, e

xtreg lw_data i.year [weight=pop], fe
predict lw_data_e, e

xtreg debt_data i.year [weight=pop], fe
predict debt_data_e, e

xtreg lq_data i.year [weight=pop], fe
predict lq_data_e, e

g Dn_bust = (ln_data_e   - L3.ln_data_e)        if year == 2010 
g Dc_bust = (lc_data_e   - L3.lc_data_e)    	if year == 2010 
g Dq_bust = (lq_data_e   - L3.lq_data_e)    	if year == 2010 
g Dw_bust = (lw_data_e   - L3.lw_data_e)    	if year == 2010 
g Dd_bust = (F.debt_data_e - L2.debt_data_e)  	if year == 2010    /* shift one since stock at 2010 determined a year earlier */

g Dn_boom = (ln_data_e   - L5.ln_data_e)       	if year == 2007
g Dc_boom = (lc_data_e   - L5.lc_data_e)    	if year == 2007 
g Dq_boom = (lq_data_e   - L5.lq_data_e)    	if year == 2007 
g Dw_boom = (lw_data_e   - L5.lw_data_e)    	if year == 2007 
g Dd_boom = (F.debt_data_e - L4.debt_data_e)  	if year == 2007    /* shift one since stock at 2006 determined a year earlier */

twoway (scatter Dn_bust Dd_bust if year == 2010, c(i l) mlabel(state) mlabc(gs0) ms(i i) yti(Log Change in Emp/Pop 07-10) xti(Change HH Debt 07 - 10 (rel. 2001 income)) xlab(-0.5(0.2)0.1) ylabel( ,grid)) , graphregion(color(white)) bgcolor(white) saving(ed_bust, replace)   

twoway (scatter Dn_boom Dd_boom if year == 2007, c(i l) mlabel(state) mlabc(gs0) ms(i i) legend(off) yti(Log Change in Emp/Pop 02-07) xti(Change in HH Debt 02 - 07 (rel. 2001 income)) xlab(-.2(0.2)0.4) ylabel( ,grid)) , graphregion(color(white)) bgcolor(white) saving(ed_boom, replace)   

twoway (scatter Dc_bust Dd_bust if year == 2010, c(i l) mlabel(state) mlabc(gs0) ms(i i) legend(off) yti(Log Change in Spending 07-10) xti(Change HH Debt 07 - 10 (rel. 2001 income)) xlab(-0.5(0.2)0.1) ylabel(,grid)) , graphregion(color(white)) bgcolor(white) saving(cd_bust, replace)   

twoway (scatter Dc_boom Dd_boom if year == 2007, c(i l) mlabel(state) mlabc(gs0) ms(i i) legend(off) yti(Log Change in Spending 02-07) xti(Change in HH Debt 02 - 07 (rel. 2001 income)) xlab(-.2(0.2)0.4) ylabel(,grid)) , graphregion(color(white)) bgcolor(white) saving(cd_boom, replace) 

graph combine ed_boom.gph ed_bust.gph cd_boom.gph cd_bust.gph 

graph export "motivate_model.eps", replace 
