
clear all 
set more off 

local varlist ne ce
local datalist2 sim sim_lowalpha sim_highalpha sim_highalpha_reestimated

* Regressions in changes, in the boom

import delimited data_for_matlab_actual.csv, clear

rename v1 state
rename v2 pop
rename v3 time
rename v4 cdata
rename v5 ndata
rename v6 wdata
rename v7 ddata
rename v8 qdata

replace ndata = 100*ndata
replace cdata = 100*cdata
replace qdata = 100*qdata
replace ddata = (100/4)*ddata

xtset state time

g Dn_bust = (ndata   - L3.ndata)    if time == 2010 
g Dc_bust = (cdata   - L3.cdata)    if time == 2010 
g Dq_bust = (qdata   - L3.qdata)    if time == 2010 
g Dd_bust = (F.ddata - L2.ddata)  	if time == 2010    

g Dn_boom = (ndata   - L5.ndata)    if time == 2007
g Dc_boom = (cdata   - L5.cdata)    if time == 2007 
g Dq_boom = (qdata   - L5.qdata)    if time == 2007 
g Dd_boom = (F.ddata - L4.ddata)  	if time == 2007 

label var Dn_boom "$\Delta$ Empl"
label var Dc_boom "$\Delta$ Cons"
label var Dd_boom "$\Delta$ Debt"   

eststo: reg Dn_boom Dd_boom if time==2007
eststo: reg Dc_boom Dd_boom if time==2007

foreach x of local datalist2 {

import delimited data_for_matlab_`x'.csv, clear

rename v1 state
rename v2 pop
rename v3 time
rename v4 cdata
rename v5 ndata
rename v6 wdata
rename v7 ddata
rename v8 qdata

replace ndata = 100*ndata
replace cdata = 100*cdata
replace qdata = 100*qdata
replace ddata = (100/4)*ddata

xtset state time

g Dn_bust = (ndata   - L3.ndata)    
g Dc_bust = (cdata   - L3.cdata)    
g Dq_bust = (qdata   - L3.qdata)    
g Dd_bust = (F.ddata - L2.ddata)  	

g Dn_boom = (ndata   - L5.ndata)    
g Dc_boom = (cdata   - L5.cdata)    
g Dq_boom = (qdata   - L5.qdata)    
g Dd_boom = (F.ddata - L4.ddata)  	

label var Dn_boom "$\Delta$ Empl"
label var Dc_boom "$\Delta$ Cons"
label var Dd_boom "$\Delta$ Debt"

eststo: reg Dn_boom Dd_boom 
eststo: reg Dc_boom Dd_boom 
}

esttab using ms_reg_table_boom.tex, se b(2) nofloat r2 label replace booktabs alignment(D{.}{.}{2.2})

eststo clear


* Regressions in changes, in the bust

import delimited data_for_matlab_actual.csv, clear

rename v1 state
rename v2 pop
rename v3 time
rename v4 cdata
rename v5 ndata
rename v6 wdata
rename v7 ddata
rename v8 qdata

replace ndata = 100*ndata
replace cdata = 100*cdata
replace qdata = 100*qdata
replace ddata = (100/4)*ddata

xtset state time

g Dn_bust = (ndata   - L3.ndata)    if time == 2010 
g Dc_bust = (cdata   - L3.cdata)    if time == 2010 
g Dq_bust = (qdata   - L3.qdata)    if time == 2010 
g Dd_bust = (F.ddata - L2.ddata)  	if time == 2010    

g Dn_boom = (ndata   - L5.ndata)    if time == 2007
g Dc_boom = (cdata   - L5.cdata)    if time == 2007 
g Dq_boom = (qdata   - L5.qdata)    if time == 2007 
g Dd_boom = (F.ddata - L4.ddata)  	if time == 2007    

label var Dn_bust "$\Delta$ Empl"
label var Dc_bust "$\Delta$ Cons"
label var Dd_bust "$\Delta$ Debt"

eststo: reg Dn_bust Dd_bust if time==2010
eststo: reg Dc_bust Dd_bust if time==2010

foreach x of local datalist2 {

import delimited data_for_matlab_`x'.csv, clear

rename v1 state
rename v2 pop
rename v3 time
rename v4 cdata
rename v5 ndata
rename v6 wdata
rename v7 ddata
rename v8 qdata

replace ndata = 100*ndata
replace cdata = 100*cdata
replace qdata = 100*qdata
replace ddata = (100/4)*ddata

xtset state time

g Dn_bust = (ndata   - L3.ndata)    
g Dc_bust = (cdata   - L3.cdata)    
g Dq_bust = (qdata   - L3.qdata)    
g Dd_bust = (F.ddata - L2.ddata)  	

g Dn_boom = (ndata   - L5.ndata)    
g Dc_boom = (cdata   - L5.cdata)    
g Dq_boom = (qdata   - L5.qdata)    
g Dd_boom = (F.ddata - L4.ddata)  	

label var Dn_bust "$\Delta$ Empl"
label var Dc_bust "$\Delta$ Cons"
label var Dd_bust "$\Delta$ Debt"

eststo: reg Dn_bust Dd_bust 
eststo: reg Dc_bust Dd_bust
}

esttab using ms_reg_table_bust.tex, se b(2) nofloat r2 label replace booktabs alignment(D{.}{.}{2.2})

eststo clear


